# ======================================================================
# begin of file *tools_MPAPP.py*
# ======================================================================
# with function from the publication Primpke, S., C. Lorenz, R. Rascher-Friesenhausen, and G. Gerdts. 2017. 'An automated approach for microplastics analysis using focal plane array (FPA) FTIR microscopy and image analysis', Anal. Methods, 9: 1499-511.
#sprimpke@awi.de (c) 2019


import pandas as pd                # for data anlysis
import SimpleITK as sitk
import numpy as np
import math as mt
import numba.cuda
import time
#import cudatoolkit
# showing itk-inges with matplotlib
# taken from http://insightsoftwareconsortium.github.io/
#                   SimpleITK-Notebooks/10_matplotlib's_imshow.html


# Closing mit der Information aus zwei Bilddatein gleichzeitig, hier werde ich noch die einzelnen Pixelabrufe in den
# if Anfragen auf p_xy umstellen
# Matrix für die Nummerierung
# x_30 x_31 x_32 x_33
# x_20 x_21 x_22 x_23
# x_10 x_11 x_12 x_13
# x_00 x_01 x_02 x_03
# Es werden diagonal, in Reihe und als Schachspringer Pixel abgefragt
def closing4x4pixel(data,d=20):
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    data.reset_index(inplace=True)
    width = max(data.x)
    height = max(data.y)
    image = np.ndarray(shape=(max(data.x)+1,max(data.y)+1,2),dtype=np.float32)
    #print(data)
    #print(data.index)
    for idx in data.index:
        image[int(data.x[idx]), int(data.y[idx]),0] = np.float32(data.g[idx])
        image[int(data.x[idx]), int(data.y[idx]),1] = np.float32(data.p[idx])
        
#   @numba.guvectorize(['void(float32[:,:],float32[:,:])'], '(m,n)->(m,n)',  target='parallel')#target='cuda')
#def baselinecorrection(x,res):
#    for i in range(0,x.shape[0],1):
#        for j in range(0,x.shape[1],1):
#            if j+25 < x.shape[1]:
#                b=j+25
#            else:
#                b=x.shape[1]
#            if j-25 <= 0:
#                a=0
#           else:
 #               a=j-25
 #           res[i,j] = x[i,j]-np.amin(x[i,a:b])

    #@numba.jit(parallel = True, nogil = True)
    def analysedistance(x, y):
        if int(np.copy(image[x,y,0])) != 0 or int(np.copy(image[x+3,y,0])) != 0 or int(np.copy(image[x,y+3,0])) != 0 or int(np.copy(image[x+3,y+3,0])) != 0:
            x_00=int(np.copy(image[x,y,0]))
            p_00=int(np.copy(image[x,y,1]))
            p_01=int(np.copy(image[x+0,y+1,1]))
            p_02=int(np.copy(image[x+0,y+2,1]))
            p_03=int(np.copy(image[x+0,y+3,1]))       
            p_10=int(np.copy(image[x+1,y,1]))
            p_11=int(np.copy(image[x+1,y+1,1]))
            p_12=int(np.copy(image[x+1,y+2,1]))
            p_13=int(np.copy(image[x+1,y+3,1])) 
            p_20=int(np.copy(image[x+2,y,1]))
            p_21=int(np.copy(image[x+2,y+1,1]))
            p_22=int(np.copy(image[x+2,y+2,1]))
            p_23=int(np.copy(image[x+2,y+3,1]))
            p_30=int(np.copy(image[x+3,y,1]))
            p_31=int(np.copy(image[x+3,y+1,1]))
            p_32=int(np.copy(image[x+3,y+2,1]))
            p_33=int(np.copy(image[x+3,y+3,1]))                            
            x_10=int(np.copy(image[x+1,y,0]))   
            x_20=int(np.copy(image[x+2,y,0]))
            x_30=int(np.copy(image[x+3,y,0]))
            x_01=int(np.copy(image[x,y+1,0]))
            x_11=int(np.copy(image[x+1,y+1,0]))
            x_21=int(np.copy(image[x+2,y+1,0]))
            x_31=int(np.copy(image[x+3,y+1,0]))
            x_02=int(np.copy(image[x,y+2,0]))
            x_12=int(np.copy(image[x+1,y+2,0]))
            x_22=int(np.copy(image[x+2,y+2,0])) 
            x_32=int(np.copy(image[x+3,y+2,0]))
            x_03=int(np.copy(image[x,y+3,0]))
            x_13=int(np.copy(image[x+1,y+3,0]))
            x_23=int(np.copy(image[x+2,y+3,0]))
            x_33=int(np.copy(image[x+3,y+3,0]))
        #Untere Ecke links
            if x_00>0 and x_02>0 and x_01==0 and p_00==p_02:
                xmedian=(x_02+x_00)/2
                image[x,y+1,0]=int(xmedian)
                image[x,y+1,1]=int(p_00)
            if x_00>0 and x_20>0 and x_10==0 and p_00==p_20:
                xmedian=(x_20+x_00)/2
                image[x+1,y,0]=int(xmedian)
                image[x+1,y,1]=int(p_00)
            if x_00>0 and x_22>0 and x_11==0 and p_00==p_22:
                xmedian=(x_22+x_00)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_00)
            if x_00>0 and x_03>0 and x_02==0 and x_01==0 and p_00==p_03:
                xmedian=(x_03+x_00*2)/3
                image[x,y+1,0]=int(xmedian)
                image[x,y+1,1]=int(p_00)
                xmedian=(x_03*2+x_00)/3
                image[x,y+2,0]=int(xmedian)
                image[x,y+2,1]=int(p_00)
            if x_00>0 and x_30>0 and x_20==0 and x_10==0 and p_00==p_30:
                xmedian=(x_30+x_00*2)/3
                image[x+1,y,0]=int(xmedian)
                image[x+1,y,1]=int(p_00)
                xmedian=(x_30*2+x_00)/3
                image[x+2,y,0]=int(xmedian)
                image[x+2,y,1]=int(p_00)
                
                #Obere Ecke links
            
            if x_30>0 and x_32>0 and x_31==0 and p_30==p_32:
                xmedian=(x_32+x_30)/2
                image[x+3,y+1,0]=int(xmedian)
                image[x+3,y+1,1]=int(p_30)
            if x_30>0 and x_10>0 and x_20==0 and p_30==p_10:
                xmedian=(x_10+x_30)/2
                image[x+2,y,0]=int(xmedian)
                image[x+2,y,1]=int(p_30)
            if x_30>0 and x_12>0 and x_21==0 and p_30==p_12:
                xmedian=(x_12+x_30)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_30)
            if x_30>0 and x_33>0 and x_32==0 and x_31==0 and p_30==p_33:
                xmedian=(x_33+x_30*2)/3
                image[x+3,y+1,0]=int(xmedian)
                image[x+3,y+1,1]=int(p_30)
                xmedian=(x_33*2+x_30)/3
                image[x+3,y+2,0]=int(xmedian)
                image[x+3,y+2,1]=int(p_30)
                
             #    Obere Ecke Rechts
            
            if x_33>0 and x_31>0 and x_32==0 and p_33==p_31:
                xmedian=(x_33+x_31)/2
                image[x+3,y+2,0]=int(xmedian)
                image[x+3,y+2,1]=int(p_33)
            if x_33>0 and x_13>0 and x_23==0 and p_33==p_13:
                xmedian=(x_33+x_13)/2
                image[x+2,y+3,0]=int(xmedian)
                image[x+2,y+3,1]=int(p_33)
            if x_33>0 and x_11>0 and x_22==0 and p_33==p_11:
                xmedian=(x_11+x_33)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_33)
            if x_33>0 and x_03>0 and x_23==0 and x_13==0 and p_33==p_03:
                xmedian=(x_33+x_03*2)/3
                image[x+1,y+3,0]=int(xmedian)
                image[x+1,y+3,1]=int(p_33)
                xmedian=(x_33*2+x_03)/3
                image[x+2,y+3,0]=int(xmedian)
                image[x+2,y+3,1]=int(p_33)
    
           #     Untere Ecke rechts
            if x_03>0 and x_01>0 and x_02==0 and p_03==p_01:
                xmedian=(x_03+x_01)/2
                image[x,y+2,0]=int(xmedian)
                image[x,y+2,1]=int(p_03)
            if x_03>0 and x_23>0 and x_13==0 and p_03==p_23:
                xmedian=(x_03+x_23)/2
                image[x+1,y+3,0]=int(xmedian)
                image[x+1,y+3,1]=int(p_03)
            if x_03>0 and x_21>0 and x_12==0 and p_03==p_21:
                xmedian=(x_21+x_03)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_03)
           #     
            #     Unterer Reihe
            if x_01 > 0 and x_21>0 and x_11==0  and p_21==p_01:
                xmedian=(x_21+x_01)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_01)
            if x_01 > 0 and x_23>0 and x_12==0  and p_23==p_01:
                xmedian=(x_23+x_01)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_01)
            if x_01 > 0 and x_31>0 and x_21==0 and x_11==0  and p_31==p_01:
                xmedian=(x_31+x_01*2)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_01)
                xmedian=(x_31*2+x_01)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_01)
                
            if x_02 > 0 and x_22>0 and x_12==0  and p_22==p_02:
                xmedian=(x_22+x_02)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_02)
            if x_02 > 0 and x_20>0 and x_11==0  and p_20==p_02:
                xmedian=(x_20+x_02)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_02)
            if x_02 > 0 and x_32>0 and x_22==0 and x_12==0  and p_02==p_32:
                xmedian=(x_32+x_02*2)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_02)
                xmedian=(x_32*2+x_02)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_02)
                
            #     Obere Reihe
    
            if x_31 > 0 and x_11>0 and x_21==0 and p_31==p_11:
                xmedian=(x_11+x_31)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_31)
            if x_31 > 0 and x_13>0 and x_22==0 and p_13==p_31:
                xmedian=(x_13+x_31)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_31)
                
            if x_32 > 0 and x_12>0 and x_22==0 and p_32==p_12:
                xmedian=(x_32+x_12)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_32)
            if x_32 > 0 and x_10>0 and x_21==0 and p_32==p_10:
                xmedian=(x_32+x_10)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_32)
                
           #      Rechte Reihe
            
            if x_10 > 0 and x_12>0 and x_11==0 and p_10==p_12:
                xmedian=(x_10+x_12)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_10)
            if x_10 > 0 and x_13>0 and x_11==0 and x_12==0  and p_10==p_13:
                xmedian=(x_13+x_10*2)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_10)
                xmedian=(x_13*2+x_10)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_10)
                
            if x_20 > 0 and x_22>0 and x_21==0 and p_20==p_22:
                xmedian=(x_20+x_22)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_20)
            if x_20 > 0 and x_23>0 and x_22==0 and x_21==0  and p_20==p_23:
                xmedian=(x_23+x_20*2)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_20)
                xmedian=(x_23*2+x_20)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_20)
            
             #    Linke Reihe
            
            if x_13 > 0 and x_11>0 and x_12==0 and p_13==p_11:
                xmedian=(x_13+x_11)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_13)
            
            if x_23 > 0 and x_21>0 and x_22==0 and p_23==p_21:
                xmedian=(x_23+x_21)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_23)
                
            #    Diagonal
            if x_00>0 and x_33>0 and x_22==0 and x_11==0 and p_00==p_33:
                xmedian=(x_33+x_00*2)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_00)
                xmedian=(x_33*2+x_00)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_00)
            if x_30>0 and x_03>0 and x_12==0 and x_21==0 and p_30==p_03:
                xmedian=(x_03+x_30*2)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_30)
                xmedian=(x_03*2+x_30)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_30)
        
            #Schachspringer
        
           # Untere Reihe
        
            if x_00 >0 and x_21 >0 and x_01==0 and x_10==0 and x_11==0 and x_20==0 and p_00==p_21:
                xmedian=(x_00+x_21)/2
                image[x+1,y+0,0]=int(xmedian)
                image[x+1,y+0,1]=int(p_00)
                xmedian=(x_00+x_21)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_00)
            if x_00 >0 and x_12 >0 and x_01==0 and x_02==0 and x_10==0 and x_11==0 and p_00==p_12:
                xmedian=(x_00+x_12)/2
                image[x+0,y+1,0]=int(xmedian)
                image[x+0,y+1,1]=int(p_00)
                xmedian=(x_00+x_12)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_00)
            
            if x_01 >0 and x_22 >0 and x_02==0 and x_11==0 and x_12==0 and x_21==0 and p_01==p_22:
                xmedian=(x_01+x_22)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_01)
                xmedian=(x_01+x_22)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_01)
            if x_01 >0 and x_13 >0 and x_02==0 and x_03==0 and x_11==0 and x_12==0 and p_01==p_13:
                xmedian=(x_01+x_13)/2
                image[x+0,y+2,0]=int(xmedian)
                image[x+0,y+2,1]=int(p_01)
                xmedian=(x_01+x_13)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_01)
            if x_01 >0 and x_20 >0 and x_00==0 and x_10==0 and x_11==0 and x_12==0 and p_01==p_20:
                xmedian=(x_01+x_20)/2
                image[x+1,y+0,0]=int(xmedian)
                image[x+1,y+0,1]=int(p_01)
                xmedian=(x_01+x_20)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_01)
            
            if x_02 >0 and x_21 >0 and x_01==0 and x_11==0 and x_12==0 and x_22==0 and p_02==p_21:
                xmedian=(x_02+x_21)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_02)
                xmedian=(x_02+x_21)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_02)
            if x_02 >0 and x_23 >0 and x_03==0 and x_12==0 and x_13==0 and x_22==0 and p_02==p_23:
                xmedian=(x_02+x_23)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_02)
                xmedian=(x_02+x_23)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_02)
            if x_02 >0 and x_10 >0 and x_00==0 and x_01==0 and x_11==0 and x_12==0 and p_02==p_10:
                xmedian=(x_02+x_10)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_02)
                xmedian=(x_02+x_10)/2
                image[x+0,y+1,0]=int(xmedian)
                image[x+0,y+1,1]=int(p_02)
            
            if x_03 >0 and x_11 >0 and x_01==0 and x_02==0 and x_12==0 and x_13==0 and p_03==p_11:
                xmedian=(x_03+x_11)/2
                image[x+0,y+2,0]=int(xmedian)
                image[x+0,y+2,1]=int(p_03)
                xmedian=(x_03+x_11)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_03)
            if x_03 >0 and x_22 >0 and x_02==0 and x_12==0 and x_13==0 and x_23==0 and p_03==p_22:
                xmedian=(x_03+x_22)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_03)
                xmedian=(x_03+x_22)/2
                image[x+1,y+3,0]=int(xmedian)
                image[x+1,y+3,1]=int(p_03)
        
        
        
             #   Obere Reihe
            if x_30 >0 and x_11 >0 and x_20==0 and x_10==0 and x_31==0 and x_21==0 and p_30==p_11:
                xmedian=(x_30+x_11)/2
                image[x+2,y+0,0]=int(xmedian)
                image[x+2,y+0,1]=int(p_30)
                xmedian=(x_30+x_11)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_30)
            if x_30 >0 and x_22 >0 and x_31==0 and x_32==0 and x_20==0 and x_21==0 and p_30==p_22:
                xmedian=(x_30+x_22)/2
                image[x+3,y+1,0]=int(xmedian)
                image[x+3,y+1,1]=int(p_30)
                xmedian=(x_30+x_22)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_30)
                
            if x_31 >0 and x_10 >0 and x_30==0 and x_20==0 and x_21==0 and x_11==0 and p_31==p_10:
                xmedian=(x_31+x_10)/2
                image[x+2,y+0,0]=int(xmedian)
                image[x+2,y+0,1]=int(p_31)
                xmedian=(x_31+x_10)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_31)
            if x_31 >0 and x_12 >0 and x_32==0 and x_21==0 and x_22==0 and x_11==0 and p_31==p_12:
                xmedian=(x_31+x_12)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_31)
                xmedian=(x_31+x_12)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_31)
            if x_31 >0 and x_23 >0 and x_21==0 and x_32==0 and x_22==0 and x_23==0 and p_31==p_23:
                xmedian=(x_31+x_23)/2
                image[x+3,y+2,0]=int(xmedian)
                image[x+3,y+2,1]=int(p_31)
                xmedian=(x_31+x_23)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_31)
            
            if x_32 >0 and x_11 >0 and x_31==0 and x_21==0 and x_22==0 and x_12==0 and p_32==p_11:
                xmedian=(x_32+x_11)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_32)
                xmedian=(x_32+x_11)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_32)
            if x_32 >0 and x_13 >0 and x_33==0 and x_22==0 and x_23==0 and x_12==0 and p_32==p_32:
                xmedian=(x_32+x_13)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_32)
                xmedian=(x_32+x_13)/2
                image[x+2,y+3,0]=int(xmedian)
                image[x+2,y+3,1]=int(p_32)
            if x_32 >0 and x_20 >0 and x_30==0 and x_31==0 and x_21==0 and x_22==0 and p_32==p_02:
                xmedian=(x_32+x_20)/2
                image[x+3,y+1,0]=int(xmedian)
                image[x+3,y+1,1]=int(p_32)
                xmedian=(x_32+x_20)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_32)
            
            if x_33 >0 and x_21 >0 and x_31==0 and x_32==0 and x_22==0 and x_23==0 and p_33==p_21:
                xmedian=(x_33+x_21)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_33)
                xmedian=(x_33+x_21)/2
                image[x+3,y+2,0]=int(xmedian)
                image[x+3,y+2,1]=int(p_33)
            if x_33 >0 and x_12 >0 and x_32==0 and x_22==0 and x_23==0 and x_13==0 and p_33==p_12:
                xmedian=(x_33+x_12)/2
                image[x+3,y+2,0]=int(xmedian)
                image[x+3,y+2,1]=int(p_33)
                xmedian=(x_33+x_12)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_33)
            # Seiten
            if x_10 >0 and x_22 >0 and x_11==0 and x_12==0 and x_20==0 and x_21==0 and p_10==p_22:
                xmedian=(x_10+x_22)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_22)
                xmedian=(x_10+x_22)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_22)
            if x_20 >0 and x_12 >0 and x_10==0 and x_11==0 and x_21==0 and x_22==0 and p_20==p_12:
                xmedian=(x_20+x_12)/2
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_20)
                xmedian=(x_20+x_12)/2
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_20)
            if x_13 >0 and x_21 >0 and x_11==0 and x_12==0 and x_22==0 and x_23==0 and p_13==p_21:
                xmedian=(x_13+x_21)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_13)
                xmedian=(x_13+x_21)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_13)
            if x_23 >0 and x_11 >0 and x_12==0 and x_13==0 and x_21==0 and x_22==0 and p_23==p_11:
                xmedian=(x_23+x_11)/2
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_23)
                xmedian=(x_23+x_11)/2
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_23)
        
             #Die vierer Abfrage
        
                # Untere Reihe = Oberer Reihe
            if x_00 >0 and x_31 >0 and x_01==0 and x_10==0 and x_11==0 and x_20==0 and x_21==0 and x_30==0 and p_00==p_31:
                xmedian=(x_00*2+x_31)/3
                image[x+1,y+0,0]=int(xmedian)
                image[x+1,y+0,1]=int(p_00)
                xmedian=(x_00+x_31*2)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_00)
            if x_00 >0 and x_32 >0 and x_01==0 and x_10==0 and x_11==0 and x_21==0 and x_22==0 and x_31==0 and p_00==p_32:
                xmedian=(x_00*2+x_32)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_00)
                xmedian=(x_00+x_32*2)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_00)
                
            if x_01 >0 and x_30 >0 and x_00==0 and x_10==0 and x_11==0 and x_20==0 and x_21==0 and x_31==0 and p_01==p_30:
                xmedian=(x_01*2+x_30)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_01)
                xmedian=(x_01+x_30*2)/3
                image[x+2,y+0,0]=int(xmedian)
                image[x+2,y+0,1]=int(p_01)
            if x_01 >0 and x_32 >0 and x_02==0 and x_11==0 and x_12==0 and x_21==0 and x_22==0 and x_31==0 and p_01==p_32:
                xmedian=(x_01*2+x_32)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_01)
                xmedian=(x_01+x_32*2)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_01)
            if x_01 >0 and x_33 >0 and x_02==0 and x_11==0 and x_12==0 and x_22==0 and x_23==0 and x_32==0 and p_01==p_33:
                xmedian=(x_01*2+x_33)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_01)
                xmedian=(x_01+x_33*2)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_01)
                
            if x_02 >0 and x_30 >0 and x_01==0 and x_11==0 and x_12==0 and x_20==0 and x_21==0 and x_31==0 and p_02==p_30:
                xmedian=(x_02*2+x_30)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_02)
                xmedian=(x_02+x_30*2)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_02)
            if x_02 >0 and x_31 >0 and x_01==0 and x_11==0 and x_12==0 and x_21==0 and x_22==0 and x_32==0 and p_02==p_31:
                xmedian=(x_02*2+x_31)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_02)
                xmedian=(x_02+x_31*2)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_02)
            if x_02 >0 and x_33 >0 and x_03==0 and x_12==0 and x_13==0 and x_22==0 and x_23==0 and x_32==0 and p_02==p_33:
                xmedian=(x_02*2+x_33)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_02)
                xmedian=(x_02+x_33*2)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_02)
                
            if x_03 >0 and x_31 >0 and x_02==0 and x_12==0 and x_13==0 and x_21==0 and x_22==0 and x_32==0 and p_03==p_31:
                xmedian=(x_03*2+x_31)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_03)
                xmedian=(x_03+x_31*2)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_03)
            if x_03 >0 and x_32 >0 and x_02==0 and x_12==0 and x_13==0 and x_22==0 and x_23==0 and x_33==0 and p_03==p_32:
                xmedian=(x_03*2+x_32)/3
                image[x+1,y+3,0]=int(xmedian)
                image[x+1,y+3,1]=int(p_03)
                xmedian=(x_03+x_32*2)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_03)
        
            #Linke Reihe = Rechte Reihe 
            if x_00 >0 and x_13 >0 and x_01==0 and x_10==0 and x_11==0 and x_12==0 and x_22==0 and x_23==0 and p_00==p_13:
                xmedian=(x_00*2+x_13)/3
                image[x+0,y+0,0]=int(xmedian)
                image[x+0,y+0,1]=int(p_00)
                xmedian=(x_00+x_13*2)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_00)
            if x_00 >0 and x_23 >0 and x_01==0 and x_10==0 and x_11==0 and x_12==0 and x_13==0 and x_22==0 and p_00==p_23:
                xmedian=(x_00*2+x_23)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_00)
                xmedian=(x_00+x_23*2)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_00)
                
            if x_10 >0 and x_03 >0 and x_00==0 and x_01==0 and x_11==0 and x_12==0 and x_13==0 and x_02==0 and p_10==p_03:
                xmedian=(x_10*2+x_03)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_10)
                xmedian=(x_10+x_03*2)/3
                image[x+0,y+2,0]=int(xmedian)
                image[x+0,y+2,1]=int(p_10)
            if x_10 >0 and x_23 >0 and x_11==0 and x_12==0 and x_13==0 and x_20==0 and x_21==0 and x_22==0 and p_10==p_23:
                xmedian=(x_10*2+x_23)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_10)
                xmedian=(x_10+x_23*2)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_10)
            if x_10 >0 and x_33 >0 and x_11==0 and x_20==0 and x_21==0 and x_22==0 and x_23==0 and x_32==0 and p_10==p_33:
                xmedian=(x_10*2+x_33)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_10)
                xmedian=(x_10+x_33*2)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_10)
                
            if x_20 >0 and x_03 >0 and x_02==0 and x_10==0 and x_11==0 and x_12==0 and x_13==0 and x_21==0 and p_20==p_03:
                xmedian=(x_20*2+x_03)/3
                image[x+1,y+1,0]=int(xmedian)
                image[x+1,y+1,1]=int(p_20)
                xmedian=(x_20+x_03*2)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_20)
            if x_20 >0 and x_13 >0 and x_10==0 and x_11==0 and x_12==0 and x_21==0 and x_22==0 and x_23==0 and p_20==p_13:
                xmedian=(x_20*2+x_13)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_20)
                xmedian=(x_20+x_13*2)/3
                image[x+1,y+2,0]=int(xmedian)
                image[x+1,y+2,1]=int(p_20)
            if x_20 >0 and x_33 >0 and x_21==0 and x_22==0 and x_23==0 and x_30==0 and x_31==0 and x_32==0 and p_20==p_33:
                xmedian=(x_20*2+x_33)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_20)
                xmedian=(x_20+x_33*2)/3
                image[x+3,y+2,0]=int(xmedian)
                image[x+3,y+2,1]=int(p_20)
                
            if x_30 >0 and x_13 >0 and x_12==0 and x_20==0 and x_21==0 and x_22==0 and x_23==0 and x_31==0 and p_30==p_13:
                xmedian=(x_30*2+x_13)/3
                image[x+2,y+1,0]=int(xmedian)
                image[x+2,y+1,1]=int(p_30)
                xmedian=(x_30+x_13*2)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_30)
            if x_30 >0 and x_23 >0 and x_20==0 and x_21==0 and x_22==0 and x_31==0 and x_32==0 and x_33==0 and p_30==p_23:
                xmedian=(x_30*2+x_23)/3
                image[x+3,y+1,0]=int(xmedian)
                image[x+3,y+1,1]=int(p_30)
                xmedian=(x_30+x_23*2)/3
                image[x+2,y+2,0]=int(xmedian)
                image[x+2,y+2,1]=int(p_30)
        
    # Die Abfrage erfolgt für in drei Richtungen nach oben, zur Seite und diagonal und wird 20 mal wiederholt.
    # Diese ist im Rahmen der Funktion schneller, als die Daten nach jedem Durchgang in einen Datenframe umzuwandeln
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    k=0
    if d == 0:
        d=20
    for k in range(0,d+1,1):
        print(time.strftime("%d.%m.%Y %H:%M:%S"))
        for i in range(0, width-3, 4):
            for j in range(0, height-3, 4):
                analysedistance(i, j)
        for i in range(1, width-3, 4):
            for j in range(1, height-3, 4):
                analysedistance(i, j)
        for i in range(2, width-3, 4):
            for j in range(2, height-3, 4):
                analysedistance(i, j)
        for i in range(3, width-3, 4):
            for j in range(3, height-3, 4):
                analysedistance(i, j)
        for i in range(1, width-3, 4):
            for j in range(0, height-3, 4):
                analysedistance(i, j)
        for i in range(2, width-3, 4):
            for j in range(0, height-3, 4):
                analysedistance(i, j)
        for i in range(3, width-3, 4):
            for j in range(0, height-3, 4):
                analysedistance(i, j)
        for i in range(0, width-3, 4):
            for j in range(1, height-3, 4):
                analysedistance(i, j)
        for i in range(0, width-3, 4):
            for j in range(2, height-3, 4):
                analysedistance(i, j)
        for i in range(0, width-3, 4):
            for j in range(3, height-3, 4):
                analysedistance(i, j)
        for i in range(2, width-3, 4):
            for j in range(1, height-3, 4):
                analysedistance(i, j)
        for i in range(3, width-3, 4):
            for j in range(1, height-3, 4):
                analysedistance(i, j)
        for i in range(3, width-3, 4):
            for j in range(2, height-3, 4):
                analysedistance(i, j)
        for i in range(1, width-3, 4):
            for j in range(2, height-3, 4):
                analysedistance(i, j)
        for i in range(1, width-3, 4):
            for j in range(3, height-3, 4):
                analysedistance(i, j)
        for i in range(2, width-3, 4):
            for j in range(3, height-3, 4):
                analysedistance(i, j)                
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    data2=ndarray2dataframe(image,width,height)
    return data2

def pdmv3x3pixel(data,d=20):
    image = data2image(data)
    image2 = polymerdata2image(data)
    width = image.GetWidth()
    height = image.GetHeight()
    def analyseparticle(x, y):
        nonlocal image
        nonlocal image2
        nonlocal width
        nonlocal height
        # x and y are at position p_11
        p_11=int(image2.GetPixel(x+0,y+0,0))
        if p_11 > 0 : #read out the surrounding pixels
            if x-1 >= 1 and x + 1 < width and y - 1 >= 1 and y + 1 > height:
                p_00=int(image2.GetPixel(x-1,y-1,0))
                p_01=int(image2.GetPixel(x-1,y+0,0))
                p_02=int(image2.GetPixel(x-1,y+1,0))   
                p_10=int(image2.GetPixel(x+0,y-1,0))
                p_12=int(image2.GetPixel(x+0,y+1,0))
                p_20=int(image2.GetPixel(x+1,y-1,0))
                p_21=int(image2.GetPixel(x+1,y+0,0))
                p_22=int(image2.GetPixel(x+1,y+1,0))
                # Set the gray value with the highest number
                image2.SetPixel(x+0,y+0,int(getmainpixel(p1=p_11,p2=p_00,p3=p_01,p4=p_02,p5=p_10,p6=p_12,p7=p_20,p8=p_21,p9=p_22)))
                
            elif x-1 >= 1 and x + 1 < width and y - 1 >= 1:
                p_00=int(image2.GetPixel(x-1,y-1,0))
                p_01=int(image2.GetPixel(x-1,y+0,0)) 
                p_10=int(image2.GetPixel(x+0,y-1,0))
                p_20=int(image2.GetPixel(x+1,y-1,0))
                p_21=int(image2.GetPixel(x+1,y+0,0))
                # Set the gray value with the highest number
                image2.SetPixel(x+0,y+0,int(getmainpixel(p1=p_11,p2=p_00,p3=p_01,p4=0,p5=p_10,p6=0,p7=p_20,p8=p_21,p9=0)))
            elif x-1 >= 1 and x + 1 < width and y + 1 > height:
                p_01=int(image2.GetPixel(x-1,y+0,0))
                p_02=int(image2.GetPixel(x-1,y+1,0))   
                p_12=int(image2.GetPixel(x+0,y+1,0))
                p_21=int(image2.GetPixel(x+1,y+0,0))
                p_22=int(image2.GetPixel(x+1,y+1,0))
                # Set the gray value with the highest number
                image2.SetPixel(x+0,y+0,int(getmainpixel(p1=p_11,p2=0,p3=p_01,p4=p_02,p5=0,p6=p_12,p7=0,p8=p_21,p9=p_22)))
            elif x-1 >= 1 and y - 1 >= 1 and y + 1 > height:
                p_00=int(image2.GetPixel(x-1,y-1,0))
                p_01=int(image2.GetPixel(x-1,y+0,0))
                p_02=int(image2.GetPixel(x-1,y+1,0))   
                p_10=int(image2.GetPixel(x+0,y-1,0))
                p_12=int(image2.GetPixel(x+0,y+1,0))
                # Set the gray value with the highest number
                image2.SetPixel(x+0,y+0,int(getmainpixel(p1=p_11,p2=p_00,p3=p_01,p4=p_02,p5=p_10,p6=p_12,p7=0,p8=0,p9=0)))
            elif x + 1 < width and y - 1 >= 1 and y + 1 > height:  
                p_10=int(image2.GetPixel(x+0,y-1,0))
                p_12=int(image2.GetPixel(x+0,y+1,0))
                p_20=int(image2.GetPixel(x+1,y-1,0))
                p_21=int(image2.GetPixel(x+1,y+0,0))
                p_22=int(image2.GetPixel(x+1,y+1,0))
                # Set the gray value with the highest number
                image2.SetPixel(x+0,y+0,int(getmainpixel(p1=p_11,p2=0,p3=0,p4=0,p5=p_10,p6=p_12,p7=p_20,p8=p_21,p9=p_22)))
            elif x + 1 < width and y + 1 > height: 
                p_12=int(image2.GetPixel(x+0,y+1,0))
                p_21=int(image2.GetPixel(x+1,y+0,0))
                p_22=int(image2.GetPixel(x+1,y+1,0))
                # Set the gray value with the highest number
                image2.SetPixel(x+0,y+0,int(getmainpixel(p1=p_11,p2=0,p3=0,p4=0,p5=0,p6=p_12,p7=0,p8=p_21,p9=p_22)))
            elif x + 1 < width and y - 1 >= 1:   
                p_10=int(image2.GetPixel(x+0,y-1,0))
                p_20=int(image2.GetPixel(x+1,y-1,0))
                p_21=int(image2.GetPixel(x+1,y+0,0))
                # Set the gray value with the highest number
                image2.SetPixel(x+0,y+0,int(getmainpixel(p1=p_11,p2=0,p3=0,p4=0,p5=p_10,p6=0,p7=p_20,p8=p_21,p9=0)))
            elif x-1 >= 1 and y + 1 > height:
                p_01=int(image2.GetPixel(x-1,y+0,0))
                p_02=int(image2.GetPixel(x-1,y+1,0))   
                p_12=int(image2.GetPixel(x+0,y+1,0))
                # Set the gray value with the highest number
                image2.SetPixel(x+0,y+0,int(getmainpixel(p1=p_11,p2=0,p3=p_01,p4=p_02,p5=0,p6=p_12,p7=0,p8=0,p9=0)))
            elif x-1 >= 1 and y - 1 >= 1:
                p_00=int(image2.GetPixel(x-1,y-1,0))
                p_01=int(image2.GetPixel(x-1,y+0,0))  
                p_10=int(image2.GetPixel(x+0,y-1,0))
                # Set the gray value with the highest number
                image2.SetPixel(x+0,y+0,int(getmainpixel(p1=p_11,p2=p_00,p3=p_01,p4=0,p5=p_10,p6=0,p7=0,p8=0,p9=0)))
        
        return
    
    def getmainpixel(p1 = 0,p2 = 0,p3 = 0,p4 = 0,p5 = 0,p6 = 0,p7 = 0,p8 = 0,p9 = 0):
        count = 0
        p1match = 0
        p2match = 0
        p3match = 0
        p4match = 0
        p5match = 0
        p6match = 0
        p7match = 0
        p8match = 0
        p9match = 0
        #Read out the values for voting
        if p1 > 0:
            count += 1
            if p1 == p2:
                p1match +=1
            if p1 == p3:
                p1match +=1
            if p1 == p4:
                p1match +=1
            if p1 == p5:
                p1match +=1
            if p1 == p6:
                p1match +=1
            if p1 == p7:
                p1match +=1
            if p1 == p8:
                p1match +=1
            if p1 == p9:
                p1match +=1
        if p2 > 0:
            count += 1
            if p2 == p1:
                p2match +=1
            if p2 == p3:
                p2match +=1
            if p2 == p4:
                p2match +=1
            if p2 == p5:
                p2match +=1
            if p2 == p6:
                p2match +=1
            if p2 == p7:
                p2match +=1
            if p2 == p8:
                p2match +=1
            if p2 == p9:
                p2match +=1
        if p3 > 0:
            count += 1
            if p3 == p2:
                p3match +=1
            if p3 == p1:
                p3match +=1
            if p3 == p4:
                p3match +=1
            if p3 == p5:
                p3match +=1
            if p3 == p6:
                p3match +=1
            if p3 == p7:
                p3match +=1
            if p3 == p8:
                p3match +=1
            if p3 == p9:
                p3match +=1
        if p4 > 0:
            count += 1
            if p4 == p2:
                p4match +=1
            if p4 == p3:
                p4match +=1
            if p4 == p1:
                p4match +=1
            if p1 == p5:
                p4match +=1
            if p4 == p6:
                p4match +=1
            if p4 == p7:
                p4match +=1
            if p4 == p8:
                p4match +=1
            if p4 == p9:
                p4match +=1
        if p5 > 0:
            count += 1
            if p5 == p2:
                p5match +=1
            if p5 == p3:
                p5match +=1
            if p5 == p1:
                p5match +=1
            if p5 == p5:
                p5match +=1
            if p5 == p6:
                p5match +=1
            if p5 == p7:
                p5match +=1
            if p5 == p8:
                p5match +=1
            if p5 == p9:
                p5match +=1
        if p6 > 0:
            count += 1
            if p6 == p2:
                p6match +=1
            if p6 == p3:
                p6match +=1
            if p6 == p4:
                p6match +=1
            if p6 == p5:
                p6match +=1
            if p6 == p1:
                p6match +=1
            if p6 == p7:
                p6match +=1
            if p6 == p8:
                p6match +=1
            if p6 == p9:
                p6match +=1
        if p7 > 0:
            count += 1
            if p7 == p2:
                p7match +=1
            if p7 == p3:
                p7match +=1
            if p7 == p4:
                p7match +=1
            if p7 == p5:
                p7match +=1
            if p7 == p6:
                p7match +=1
            if p7 == p1:
                p7match +=1
            if p7 == p8:
                p7match +=1
            if p7 == p9:
                p7match +=1
        if p8 > 0:
            count += 1
            if p8 == p2:
                p8match +=1
            if p8 == p3:
                p8match +=1
            if p8 == p4:
                p8match +=1
            if p8 == p5:
                p8match +=1
            if p8 == p6:
                p8match +=1
            if p8 == p7:
                p8match +=1
            if p8 == p1:
                p8match +=1
            if p8 == p9:
                p8match +=1
        if p9 > 0:
            count += 1
            if p9 == p2:
                p9match +=1
            if p9 == p3:
                p9match +=1
            if p9 == p4:
                p9match +=1
            if p9 == p5:
                p9match +=1
            if p9 == p6:
                p9match +=1
            if p9 == p7:
                p9match +=1
            if p9 == p8:
                p9match +=1
            if p9 == p1:
                p9match +=1
        #Read out the vote and determine the major pixel
        if count > 1:
            pmax = max(p1match,p2match,p3match,p4match,p5match,p6match,p7match,p8match,p9match)
            Match = False
            if not Match and p1match == pmax:
                Match = True
                pixel = p1
            if not Match and p2match == pmax:
                Match = True
                pixel = p2
            if not Match and p3match == pmax:
                Match = True
                pixel = p3
            if not Match and p4match == pmax:
                Match = True
                pixel = p4
            if not Match and p5match == pmax:
                Match = True
                pixel = p5
            if not Match and p6match == pmax:
                Match = True
                pixel = p6
            if not Match and p7match == pmax:
                Match = True
                pixel = p7
            if not Match and p8match == pmax:
                Match = True
                pixel = p8
            if not Match and p9match == pmax:
                Match = True
                pixel = p9
                            
        else: #Or just reset the grayvalue
            pixel=p1
 
        return pixel

    for i in range(1,d,1):
        x=1
        y=1
        while x < width :
            y=1
            while y < height :
                analyseparticle(x, y)
                y +=1                
            x += 1
    #Return the dataset
    data2 = image2combidata(image,image2)
    return data2
        

def image2combidata(image, image2):
    """Create image from data frame.
    
    data: data frame with columns x, y, g
    size: tuple of width and height
    
    image: size width x height image
    """
    x_max=image.GetWidth()
    y_max=image.GetHeight()
    i=0
    z=0
    dfimage=pd.DataFrame(columns=['x','y','g','p'])
    while i < x_max:
        j=0
        while j < y_max:
            if int(image.GetPixel(i,j,0))>0:
                dfimage.loc[z]=[int(i),int(j),int(image.GetPixel(i,j,0)),int(image2.GetPixel(i,j,0))]
                z=z+1
            j=j+1
        i=i+1
    return dfimage

def data2image(data, size=None):
    """Create image from data frame.
    
    data: data frame with columns x, y, g
    size: tuple of width and height
    
    image: size width x height image
    """
    if size is None:
        width, height = max(data.x)+1, max(data.y)+1
    else:
        width, height = size
        
    # create empty image of given size and data type (enough for 11-bit)    
    image = sitk.Image(int(width), int(height), sitk.sitkUInt16)
    c = 0  # success counter
    for idx in data.index:
        try:
            image[int(data.x[idx]), int(data.y[idx])] = int(data.g[idx])
            c += 1
        except:
            #print('An error occured. Not all Pixels set!')
            pass

    return image

def polymerdata2image(data, size=None):
    """Create image from data frame.
    
    data: data frame with columns x, y, g
    size: tuple of width and height
    
    image: size width x height image
    """
    if size is None:
        width, height = max(data.x)+1, max(data.y)+1
    else:
        width, height = size
        
    # create empty image of given size and data type (enough for 11-bit)    
    image = sitk.Image(int(width), int(height), sitk.sitkUInt8)
    c = 0  # success counter
    for idx in data.index:
        try:
            image[int(data.x[idx]), int(data.y[idx])] = int(data.p[idx])
            c += 1
        except:
            #print('An error occured. Not all Pixels set!')
            pass

    return image

def image2data(image):
    """Create image from data frame.
    
    data: data frame with columns x, y, g
    size: tuple of width and height
    
    image: size width x height image
    """
    x_max=image.GetWidth()
    y_max=image.GetHeight()
    i=0
    dfimage=pd.DataFrame(columns=['x','y','g'])
    z=0
    while i < x_max:
        j=1
        while j < y_max:
            if int(image.GetPixel(i,j,0))>0:
                dfimage.loc[z]=[i,j,int(image.GetPixel(i,j,0))]
                z=z+1
            j=j+1
        i=i+1
    return dfimage

def image2data_setp(image,p):
    """Create image from data frame.
    
    data: data frame with columns x, y, g
    size: tuple of width and height
    
    image: size width x height image
    """
    x_max=image.GetWidth()
    y_max=image.GetHeight()
    i=0
    dfimage=pd.DataFrame(columns=['x','y','g','p'])
    z=0
    while i < x_max:
        j=1
        while j < y_max:
            if int(image.GetPixel(i,j,0))>0:
                dfimage.loc[z]=[i,j,int(image.GetPixel(i,j,0)),p]
                z=z+1
            j=j+1
        i=i+1
    return dfimage

def data2fiberimage(data):
    array_data = data
    #array = array[1:,0:3]
    
    # Coordinates and values
    #x = array[:,0]
    #x = x.astype(int)
    #y = array[:,1]
    #y = y.astype(int)
    #val = array[:,2]
        
    
    # Create image
    dim = ([max(array_data.x)+1,max(array_data.y)+1]) 
    im = np.zeros([dim[0],dim[1]],dtype='float')
    #i = 0
    for idx in array_data.index:
        cx = int(array_data.x[idx])
        cy = int(array_data.y[idx])
        im[cx,cy] = array_data.g[idx]
        #i = i + 1
            
    #plt.figure ()
    #plt.imshow (im, interpolation='nearest', clim = (600, 1000))
    #plt.colorbar ()
    #plt.draw ()
    #plt.show ()
    return im

def calculate_distance(image):
    width = image.GetWidth()
    height = image.GetHeight()
    image2= sitk.Image(int(width), int(height), sitk.sitkUInt8)
    def analysedistance(x, y):
        nonlocal image
        nonlocal width
        nonlocal height
        if int(image.GetPixel(x,y,0)) == 0:
            field=np.ndarray(shape=(15,15),dtype = float)
            for i in range(-7,8,1):
                for j in range (-7,8,1):
                    if (x+i < 0) or (y+j < 0) or (x+i >= width) or (y+j >= height): # For data at the outer sides and corners
                        field[i+7,j+7]=255
                    elif i==0 and j==0:
                        field[i+7,j+7]=10 #Maximum Value for 15x15 matrix at center for large particles necessary
                    elif image.GetPixel(x+i,y+j,0) == 1:
                        field[i+7,j+7]=mt.sqrt((((x+i)-x)*((x+i)-x))+(((y+j)-y)*((y+j)-y))) #Calculation of the Euclean Distance between center particle and target pixel
                        #print(field[i+5,j+5])
                    else:
                        field[i+7,j+7]=255
            #print(field)
            #print(str(round(np.amin(field),0)))
            image2.SetPixel(x,y,0,int(round(np.amin(field),0)))#Minimum Value used as pyixel
        else:
            image2.SetPixel(x,y,0,0)
        return image2
    
    for i in range(0, width, 1): #Main function
            for j in range(0, height, 1):
                cimage= analysedistance(i, j)
    
    return cimage

def binary_invert(image):
    width = image.GetWidth()
    height = image.GetHeight()
    
    for i in range(0, width, 1):
            for j in range(0, height, 1):
                if image.GetPixel(i,j,0) == 0:
                    image.SetPixel(i,j,0,1)
                elif image.GetPixel(i,j,0) == 1:
                    image.SetPixel(i,j,0,0)
                else:
                    print('An error occured, values > 1 received')
    
    return image

def close_filaments(image):
    width = image.GetWidth()
    height = image.GetHeight()
    def analysefilaments(x, y):
        nonlocal image
        nonlocal width
        nonlocal height
        if int(image.GetPixel(x,y,0)) == 1: #Check for suitable pixel
            surrounding=np.ndarray(shape=(3,3), dtype = float) #Area screening, partciles with sum > 1 are not fitting for closing
            for a in range(-1,2,1):
                for b in range (-1,2,1):
                    if (x+a < 0) or (y+b < 0) or (x+a >= width) or (y+b >= height):
                        surrounding[a+1,b+1]=0
                    elif a==0 and b==0:
                        surrounding[a+1,b+1]=0
                    elif image.GetPixel(x+a,y+b,0) == 1:
                        surrounding[a+1,b+1]=1
                    else:
                        surrounding[a+1,b+1]=0
            if np.sum(surrounding, dtype=np.int32) <= 1: # Only valid for endpoints of fibers
                minv=255 #to be always true for the first hit
                x_min=x
                y_min=y #Starting point
                ed=0
                for i in range(-9,10,1): # FRF of 9
                    for j in range (-9,10,1):
                        if (x+i < 0) or (y+j < 0) or (x+i >= width) or (y+j >= height):
                            pass #Check for corner pixels
                        elif i==0 and j==0: # Center Point
                            pass 
                        elif image.GetPixel(x+i,y+j,0) == 1: 
                            surrounding2=np.ndarray(shape=(3,3), dtype = float) #If a suitable pixel is found, it is checked the same way as the center pixel
                            for c in range(-1,2,1):
                                for d in range (-1,2,1):
                                    if (x+i+c < 0) or (y+j+d < 0) or (x+i+c >= width) or (y+j+d >= height):
                                        surrounding2[c+1,d+1]=0
                                    elif c==0 and d==0:
                                        surrounding2[c+1,d+1]=0
                                    elif image.GetPixel(x+i+c,y+j+d,0) == 1:
                                        surrounding2[c+1,d+1]=1
                                    else:
                                        surrounding2[c+1,d+1]=0
                            if np.sum(surrounding2, dtype=np.int32) <= 1: # If suitable, the pixels component ID is checked
                                cimg = sitk.ConnectedComponent(image, True) #Quite time consuming yet necessary to exclude varations within the numbering due to this process
                                rimg = sitk.RelabelComponent(cimg)
                                if rimg[x,y] != rimg[x+i,y+j]:
                                    ed=mt.sqrt((((x+i)-x)*((x+i)-x))+(((y+j)-y)*((y+j)-y))) #Calculation of the Euclidean Distance
                                    if ed < minv and ed >= 2: #Distance lower 2 are normally filled by the general closing
                                        minv=ed
                                        x_min=x+i
                                        y_min=y+j                           
                        else:
                            pass

                if x_min == x: #Filling the Gap while checking for the shortes Euclidean Distance
                    if y_min == y:
                        pass
                    
                    elif y_min < y:
                        while y_min < y:
                            y_min+=1
                            image.SetPixel(x_min,y_min,0,1)
                            
                    elif y_min > y:
                        while y_min > y:
                            y_min-=1
                            image.SetPixel(x_min,y_min,0,1)
                            
                elif x_min > x:
                    if y_min == y:
                        while x_min > x:
                            x_min-=1
                            image.SetPixel(x_min,y_min,0,1)
                            
                    elif y_min < y:
                       while y_min < y or x_min > x:
                            ed1=mt.sqrt((((x_min-1)-x)*((x_min-1)-x))+(((y_min+1)-y)*((y_min+1)-y)))
                            ed2=mt.sqrt((((x_min-1)-x)*((x_min-1)-x))+(((y_min)-y)*((y_min)-y)))
                            ed3=mt.sqrt((((x_min)-x)*((x_min)-x))+(((y_min+1)-y)*((y_min+1)-y)))
                            if ed1 <= ed2 and ed1 <= ed3:
                                y_min+=1
                                x_min-=1
                                image.SetPixel(x_min,y_min,0,1)
                            elif ed2 < ed1 and ed2 < ed3:
                                x_min-=1
                                image.SetPixel(x_min,y_min,0,1)
                            elif ed3 < ed1 and ed3 < ed2:
                                y_min+=1
                                image.SetPixel(x_min,y_min,0,1)
                                
                    elif y_min > y:
                        while y_min > y or x_min > x:
                            ed1=mt.sqrt((((x_min-1)-x)*((x_min-1)-x))+(((y_min-1)-y)*((y_min-1)-y)))
                            ed2=mt.sqrt((((x_min-1)-x)*((x_min-1)-x))+(((y_min)-y)*((y_min)-y)))
                            ed3=mt.sqrt((((x_min)-x)*((x_min)-x))+(((y_min-1)-y)*((y_min-1)-y)))
                            if ed1 <= ed2 and ed1 <= ed3:
                                y_min-=1
                                x_min-=1
                                image.SetPixel(x_min,y_min,0,1)
                            elif ed2 < ed1 and ed2 < ed3:
                                x_min-=1
                                image.SetPixel(x_min,y_min,0,1)
                            elif ed3 < ed1 and ed3 < ed2:
                                y_min-=1
                                image.SetPixel(x_min,y_min,0,1)
                                
                elif x_min < x:
                    if y_min == y:
                        while x_min < x:
                            x_min+=1
                            image.SetPixel(x_min,y_min,0,1)
                    elif y_min < y:
                        
                       while y_min < y or x_min < x:
                            ed1=mt.sqrt((((x_min+1)-x)*((x_min+1)-x))+(((y_min+1)-y)*((y_min+1)-y)))
                            ed2=mt.sqrt((((x_min+1)-x)*((x_min+1)-x))+(((y_min)-y)*((y_min)-y)))
                            ed3=mt.sqrt((((x_min)-x)*((x_min)-x))+(((y_min+1)-y)*((y_min+1)-y)))
                            if ed1 <= ed2 and ed1 <= ed3:
                                y_min+=1
                                x_min+=1
                                image.SetPixel(x_min,y_min,0,1)
                            elif ed2 < ed1 and ed2 < ed3:
                                x_min+=1
                                image.SetPixel(x_min,y_min,0,1)
                            elif ed3 < ed1 and ed3 < ed2:
                                y_min+=1
                                image.SetPixel(x_min,y_min,0,1)
                                
                    elif y_min > y:
                        while y_min > y or x_min < x:
                            ed1=mt.sqrt((((x_min+1)-x)*((x_min+1)-x))+(((y_min-1)-y)*((y_min-1)-y)))
                            ed2=mt.sqrt((((x_min+1)-x)*((x_min+1)-x))+(((y_min)-y)*((y_min)-y)))
                            ed3=mt.sqrt((((x_min)-x)*((x_min)-x))+(((y_min-1)-y)*((y_min-1)-y)))
                            if ed1 <= ed2 and ed1 <= ed3:
                                y_min-=1
                                x_min+=1
                                image.SetPixel(x_min,y_min,0,1)
                            elif ed2 < ed1 and ed2 < ed3:
                                x_min+=1
                                image.SetPixel(x_min,y_min,0,1)
                            elif ed3 < ed1 and ed3 < ed2:
                                y_min-=1
                                image.SetPixel(x_min,y_min,0,1)
                
            #print(field)
            #print(str(round(np.amin(field),0)))
            #image2.SetPixel(x,y,0,int(round(np.amin(field),0)))
        return
    
    for i in range(0, width, 1): #Main funtcion
            for j in range(0, height, 1):
                analysefilaments(i, j)
    
    return image

def applymasktodata(data, bimage, size, save_name): #To address data produced by the auto analysis
    def write_image(img, name):
        Img = sitk.RescaleIntensity(img) #, outputMinimum=0, outputMaximum=255)
        Img = sitk.Cast(Img, sitk.sitkUInt8)
        #Img = sitk.InvertIntensity(Img)
        sitk.WriteImage(Img, name)
        return
    image = data2image(data,size)
    image2 = polymerdata2image(data,size)
    mask=sitk.MaskImageFilter()
    #print('Masking')
    image=mask.Execute(image,bimage)
    write_image(image, save_name)
    image2=mask.Execute(image2,bimage)
    data2 = image2combidata(image,image2)
    return data2

def ndarray2dataframe(array,x_max,y_max):
    #@numba.jit(parallel = True, nogil = True)
    def hyperhyper(array,x_max,y_max):
        arrays=np.zeros(shape=(1,4),dtype=int)
        darray=np.copy(arrays)
        for i in range (0,x_max,1):
            for j in range (0,y_max,1):
                if int(array[i,j,0])>0:
                    darray[0,0]=int(i)
                    darray[0,1]=int(j)
                    darray[0,2]=int(array[i,j,0])
                    darray[0,3]=int(array[i,j,1])
                    arrays=np.append(arrays,darray,axis=0)
        return arrays
    """Create image from data frame.
    
    data: data frame with columns x, y, g
    size: tuple of width and height
    
    image: size width x height image
    """
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    hyper=hyperhyper(array,x_max,y_max)
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    dfimage=pd.DataFrame(hyper[:,:],index=hyper[:,0],columns=['x','y','g','p'])
    dfimage.reset_index(drop=True,inplace=True)
    #qc = pd.Series(np.zeros(len(dfimage)), index=dfimage.index, name='qc') # temporary
    #dfimage_qc = pd.concat([dfimage, qc], axis=1)
    return dfimage
#=======================================================================
# end of file *tools_enhanced_fiber.py*
#=======================================================================
